/*#######################################################################################
AVR Small Webserver 

Copyright (C) 2004 Ulrich Radig

#######################################################################################*/

#ifndef _ARP_H
 #define _ARP_H
 
//Prototype
void ARP_Reply (char *buffer,int *bufferlen);

void ARP_Add_Entry(uint32_t IP, char *MAC);
void SendArpRequest(const unsigned long ulRequestedIP);
uint8_t ARP_Find(unsigned long IP, unsigned char *MAC);

//Aufbau eines ARP Header
//	
//	2 BYTE Hardware Typ				|	2 BYTE Protokoll Typ	
//	1 BYTE Lnge Hardwareadresse	|	1 BYTE Lnge Protokolladresse
//	2 BYTE Operation
//	6 BYTE MAC Adresse Absender		|	4 BYTE IP Adresse Absender
//	6 BYTE MAC Adresse Empfnger	|	4 BYTE IP Adresse Empfnger	

#define ARP_PROTOCOL_TYPE		0x0608	///< ARP protocol type (ARP isn't built on top of IP), LE
#define ARP_OFFSET				0x0E
#define ARP_DATA_SIZE			28		///< data size in ARP frame
//ARP request/reply Layout
struct ARP_Header	{
		unsigned int ARP_HWType;		//Hardware Typ enthlt den Code fr Ethernet oder andere Link Layer
		unsigned int ARP_PRType;		//Protokoll Typ enthlt den Code fr IP o. anderes bertragungsprotokoll
		unsigned char ARP_HWLen;		//Lnge der Hardwareadresse enthlt 6 fr 6 Byte lange MAC Adressen
		unsigned char ARP_PRLen;		//Lnge der Protocolladresse enthlt 4 fr 4 Byte lange IP Adressen
		unsigned int ARP_Op;			//Enthlt Code der signalisiert ob es sich um eine Anfrage o. Antwort handelt
		unsigned char ARP_SHAddr[6];	//Enthlt die MAC Adresse des Anfragenden  
		unsigned long ARP_SIPAddr;		//Enthlt die IP Adresse des Absenders
		unsigned char ARP_THAddr[6];	//MAC Adresse Ziel, ist in diesem Fall 6 * 00,da die Adresse erst noch herausgefunden werden soll (ARP Request)
		unsigned long ARP_TIPAddr;		//IP Adresse enthlt die IP Adresse zu der die Kommunikation aufgebaut werden soll 
};

/** \struct Single entry in ARP cache structure
*/
struct S_ARP_ENTRY {
	uint32_t IP;
	uint8_t MAC[6];
};
#define ARP_TABLE_SIZE 2	///< size of ARP table/cache

#endif // #define _ARP_H
